diff --git a/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
similarity index 96%
rename from src/main/java/net/minecraft/core/world/chunk/Chunk.java
rename to game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index 60c7ea72f..67c5a6bd4 100644
--- a/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.chunk;
 
 import com.mojang.logging.LogUtils;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
@@ -100,7 +101,7 @@ public class Chunk
             for(int z = 0; z < CHUNK_SIZE_Z; z++)
             {
                 int y = CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y - 1;
-                while (y > 0 && Block.lightBlock[getBlockID(x, y - 1, z)] == 0) {
+                while (y > 0 && Blocks.lightBlock[getBlockID(x, y - 1, z)] == 0) {
                     y--;
                 }
                 setHeightValue(x, z, y);
@@ -130,7 +131,7 @@ public class Chunk
                     int skyLightValue = 15;
                     int lightY = (CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y) - 1;
                     do {
-                        skyLightValue -= Block.lightBlock[getBlockID(x, lightY, z) & 0x3fff];
+                        skyLightValue -= Blocks.lightBlock[getBlockID(x, lightY, z) & 0x3fff];
                         if(skyLightValue > 0) {
                             setBrightness(LightLayer.Sky, x, lightY, z, skyLightValue);
                         }
@@ -182,7 +183,7 @@ public class Chunk
         {
             iy = y;
         }
-        for(; iy > 0 && Block.lightBlock[getBlockID(x, iy - 1, z) & 0x3fff] == 0; iy--) { }
+        for(; iy > 0 && Blocks.lightBlock[getBlockID(x, iy - 1, z) & 0x3fff] == 0; iy--) { }
         if(iy == heightValue)
         {
             return;
@@ -233,7 +234,7 @@ public class Chunk
         while(iy > 0 && lightValue > 0)
         {
             iy--;
-            int lightBlock = Block.lightBlock[getBlockID(x, iy, z)];
+            int lightBlock = Blocks.lightBlock[getBlockID(x, iy, z)];
             if(lightBlock == 0)
             {
                 lightBlock = 1;
@@ -245,7 +246,7 @@ public class Chunk
             }
             setBrightness(LightLayer.Sky, x, iy, z, lightValue);
         }
-        for(; iy > 0 && Block.lightBlock[getBlockID(x, iy - 1, z)] == 0; iy--) { }
+        for(; iy > 0 && Blocks.lightBlock[getBlockID(x, iy - 1, z)] == 0; iy--) { }
         if(iy != lightY)
         {
             world.scheduleLightingUpdate(LightLayer.Sky, worldX - 1, iy, worldZ - 1, worldX + 1, lightY, worldZ + 1);
@@ -283,7 +284,7 @@ public class Chunk
 
         if(!world.worldType.hasCeiling())
         {
-            if(Block.lightBlock[id & 0x3fff] != 0) {
+            if(Blocks.lightBlock[id & 0x3fff] != 0) {
                 if(y >= heightValue) {
                     recalcHeight(x, y + 1, z);
                 }
@@ -322,12 +323,12 @@ public class Chunk
         int worldZ = zPosition * CHUNK_SIZE_Z + z;
         if(currentId != 0 && !world.isClientSide)
         {
-            Block.blocksList[currentId].onBlockRemoved(world, worldX, y, worldZ, currentData);
+            Blocks.blocksList[currentId].onBlockRemoved(world, worldX, y, worldZ, currentData);
         }
 
         if(!world.worldType.hasCeiling())
         {
-            if(Block.lightBlock[id & 0x3fff] != 0) {
+            if(Blocks.lightBlock[id & 0x3fff] != 0) {
                 if(y >= heightValue) {
                     recalcHeight(x, y + 1, z);
                 }
@@ -341,8 +342,8 @@ public class Chunk
         world.scheduleLightingUpdate(LightLayer.Block, worldX, y, worldZ, worldX, y, worldZ);
         lightGaps(x, z);
 
-        if(Block.getBlock(id) != null) {
-            Block.blocksList[id].onBlockPlacedByWorld(world, worldX, y, worldZ);
+        if(Blocks.getBlock(id) != null) {
+            Blocks.blocksList[id].onBlockPlacedByWorld(world, worldX, y, worldZ);
         }
 
         isModified = true;
@@ -456,6 +457,7 @@ public class Chunk
     public void addEntity(Entity entity)
     {
         hasEntities = true;
+        isModified = true;
         int x = MathHelper.floor(entity.x / CHUNK_SIZE_X);
         int z = MathHelper.floor(entity.z / CHUNK_SIZE_Z);
         if(x != xPosition || z != zPosition)
@@ -494,11 +496,11 @@ public class Chunk
         if(tileEntity == null)
         {
             int id = getBlockID(x, y, z);
-            if(!Block.isEntityTile[id])
+            if(!Blocks.isEntityTile[id])
             {
                 return null;
             }
-            BlockTileEntity tileEntityBlock = (BlockTileEntity)Block.blocksList[id];
+            BlockTileEntity tileEntityBlock = (BlockTileEntity)Blocks.blocksList[id];
             tileEntityBlock.onBlockPlacedByWorld(world, xPosition * CHUNK_SIZE_X + x, y, zPosition * CHUNK_SIZE_Z + z);
             tileEntity = blockEntityMap.get(pos);
         }
@@ -535,7 +537,7 @@ public class Chunk
         tileEntity.x = xPosition * CHUNK_SIZE_X + x;
         tileEntity.y = y;
         tileEntity.z = zPosition * CHUNK_SIZE_Z + z;
-        if (!(Block.blocksList[getBlockID(x, y, z)] instanceof BlockTileEntity))
+        if (!(Blocks.blocksList[getBlockID(x, y, z)] instanceof BlockTileEntity))
         {
             LOGGER.warn("Attempted to place a tile entity where there was no entity tile!");
             Thread.dumpStack();
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
similarity index 96%
rename from src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
rename to game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index 0b1da4705..57918ce91 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.chunk;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.LightLayer;
@@ -65,7 +66,7 @@ public class ChunkCache
 
     @Override
     public Block getBlock(int x, int y, int z) {
-        return Block.getBlock(getBlockId(x, y, z));
+        return Blocks.getBlock(getBlockId(x, y, z));
     }
 
     @Override
@@ -226,14 +227,14 @@ public class ChunkCache
             return Material.air;
         } else
         {
-            return Block.blocksList[l].blockMaterial;
+            return Blocks.blocksList[l].blockMaterial;
         }
     }
 
     @Override
 	public boolean isBlockOpaqueCube(int x, int y, int z)
     {
-        Block block = Block.blocksList[getBlockId(x, y, z)];
+        Block block = Blocks.blocksList[getBlockId(x, y, z)];
         if(block == null)
         {
             return false;
@@ -246,7 +247,7 @@ public class ChunkCache
     @Override
 	public boolean isBlockNormalCube(int x, int y, int z)
     {
-        Block block = Block.blocksList[getBlockId(x, y, z)];
+        Block block = Blocks.blocksList[getBlockId(x, y, z)];
         if(block == null)
         {
             return false;
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
similarity index 99%
rename from src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
rename to game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
index c37d3ff2a..dd4557136 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkSection.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.chunk;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.LightLayer;
@@ -60,7 +61,7 @@ public class ChunkSection {
     }
 
     public void setBlock(int x, int y, int z, int id) {
-        assert id == 0 || Block.getBlock(id) != null;
+        assert id == 0 || Blocks.getBlock(id) != null;
 
         if (x < 0 || x >= Chunk.CHUNK_SIZE_X || y < 0 || y >= SECTION_SIZE_Y || z < 0 || z >= Chunk.CHUNK_SIZE_Z) return;
         if (blocks == null && id == 0) {
diff --git a/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java b/game/core/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java
similarity index 97%
rename from src/main/java/net/minecraft/core/world/chunk/LightUpdate.java
rename to game/core/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java
index c60aea73e..44cb500f6 100644
--- a/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/LightUpdate.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.chunk;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
 import org.slf4j.Logger;
@@ -73,7 +74,7 @@ public class LightUpdate
                     int savedLightValue = world.getSavedLightValue(layer, x, y, z);
                     int newLightValue;
                     int blockId = world.getBlockId(x, y, z);
-                    int blockLightOpacity = Block.lightBlock[blockId];
+                    int blockLightOpacity = Blocks.lightBlock[blockId];
 
                     if(blockLightOpacity == 0)
                     {
@@ -90,7 +91,7 @@ public class LightUpdate
                     }
                     else if(layer == LightLayer.Block)
                     {
-                        blockLightValue = Block.lightEmission[blockId];
+                        blockLightValue = Blocks.lightEmission[blockId];
                     }
 
                     if(blockLightOpacity >= 15 && blockLightValue == 0)
diff --git a/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java b/game/core/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java
similarity index 78%
rename from src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java
rename to game/core/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java
index 51f828601..ec62e906c 100644
--- a/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/MissingBlockFixer.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.chunk;
 
 import com.mojang.logging.LogUtils;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import org.slf4j.Logger;
 
 public class MissingBlockFixer
@@ -23,13 +23,13 @@ public class MissingBlockFixer
 
     static 
     {
-        blocksArray = new short[Block.blocksList.length];
+        blocksArray = new short[Blocks.blocksList.length];
         try
         {
-            for (int i = 0; i < Block.blocksList.length; i++)
+            for (int i = 0; i < Blocks.blocksList.length; i++)
             {
                 short id = (short)i;
-                if(id != 0 && Block.blocksList[id & 0x3FFF] == null)
+                if(id != 0 && Blocks.blocksList[id & 0x3FFF] == null)
                 {
                 	id = 0;
                 }
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGeneratorResult.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGeneratorResult.java
similarity index 94%
rename from src/main/java/net/minecraft/core/world/generate/chunk/ChunkGeneratorResult.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGeneratorResult.java
index 680286b03..c9b0b5e25 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGeneratorResult.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/ChunkGeneratorResult.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.chunk;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
 
@@ -22,7 +23,7 @@ public class ChunkGeneratorResult {
         int section = y / ChunkSection.SECTION_SIZE_Y;
         int cy = y % ChunkSection.SECTION_SIZE_Y;
 
-        Block newBlock = Block.getBlock(id);
+        Block newBlock = Blocks.getBlock(id);
 
         // If the array is null and we're only clearing a block, skip creating it; otherwise, create it
         if (sectionBlocksArray[section] == null) {
@@ -34,7 +35,7 @@ public class ChunkGeneratorResult {
         }
 
         // Increment or decrement numBlocksInSection depending on whether we're setting or clearing a block
-        Block currentBlock = Block.getBlock(getBlock(x, y, z));
+        Block currentBlock = Blocks.getBlock(getBlock(x, y, z));
         if (newBlock == null && currentBlock != null) {
             numBlocksInSectionArray[section]--;
         } else if (newBlock != null && currentBlock == null) {
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java
similarity index 84%
rename from src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java
index 87360d25b..131e1dc52 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/debug/ChunkDecoratorDebug.java
@@ -1,38 +1,38 @@
-package net.minecraft.core.world.generate.chunk.debug;
-
-import net.minecraft.core.block.Block;
-import net.minecraft.core.world.chunk.Chunk;
-import net.minecraft.core.world.generate.chunk.ChunkDecorator;
-
-public class ChunkDecoratorDebug
-    implements ChunkDecorator
-{
-    @Override
-    public void decorate(Chunk chunk)
-    {
-        int chunkX = chunk.xPosition;
-        int chunkZ = chunk.zPosition;
-
-        int chunkBlockOffset = chunkX * (Chunk.CHUNK_SIZE_X / 2);
-        int chunkMetaOffset = chunkZ * (Chunk.CHUNK_SIZE_Z / 2);
-
-        for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++)
-        {
-            for (int z =  0; z < Chunk.CHUNK_SIZE_X; z++)
-            {
-                int blockBlockOffset = x / 2;
-                int blockMetaOffset = z / 2;
-
-                if (x % 2 == 0 && z % 2 == 0)
-                {
-                    int blockId = chunkBlockOffset + blockBlockOffset;
-                    int meta = chunkMetaOffset + blockMetaOffset;
-
-                    if (blockId < 0 || blockId >= Block.blocksList.length || Block.blocksList[blockId] == null) continue;
-
-                    chunk.setBlockIDWithMetadata(x, 0, z, blockId, meta);
-                }
-            }
-        }
-    }
-}
+package net.minecraft.core.world.generate.chunk.debug;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.generate.chunk.ChunkDecorator;
+
+public class ChunkDecoratorDebug
+    implements ChunkDecorator
+{
+    @Override
+    public void decorate(Chunk chunk)
+    {
+        int chunkX = chunk.xPosition;
+        int chunkZ = chunk.zPosition;
+
+        int chunkBlockOffset = chunkX * (Chunk.CHUNK_SIZE_X / 2);
+        int chunkMetaOffset = chunkZ * (Chunk.CHUNK_SIZE_Z / 2);
+
+        for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++)
+        {
+            for (int z =  0; z < Chunk.CHUNK_SIZE_X; z++)
+            {
+                int blockBlockOffset = x / 2;
+                int blockMetaOffset = z / 2;
+
+                if (x % 2 == 0 && z % 2 == 0)
+                {
+                    int blockId = chunkBlockOffset + blockBlockOffset;
+                    int meta = chunkMetaOffset + blockMetaOffset;
+
+                    if (blockId < 0 || blockId >= Blocks.blocksList.length || Blocks.blocksList[blockId] == null) continue;
+
+                    chunk.setBlockIDWithMetadata(x, 0, z, blockId, meta);
+                }
+            }
+        }
+    }
+}
